Index: /LMDZ5/trunk/libf/phylmd/cvltr_scav.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/cvltr_scav.F90	(revision 2283)
+++ /LMDZ5/trunk/libf/phylmd/cvltr_scav.F90	(revision 2284)
@@ -122,22 +122,24 @@
   real                           :: conservMA
 
-  ! ======================================================
-  ! calcul de l'impaction
-  ! ======================================================
-
-  ! impaction sur la surface de la colonne de la descente insaturee
-  ! On prend la moyenne des precip entre le niveau i+1 et i
-  ! I=3/4* (P(1+1)+P(i))/2 / (sigd*r*rho_l)
-  ! 1000kg/m3= densite de l'eau
-  ! 0.75e-3 = 3/4 /1000
-  ! Par la suite, I est tout le temps multiplie par sig_d pour avoir l'impaction sur la surface de la maille
-  ! on le neglige ici pour simplifier le code
-
-  DO j=1,klev-1
-     DO i=1,klon
-        imp(i,j) = coefcoli_3d(i,j)*0.75e-3/rdrop *&
-             0.5*(pmflxr(i,j+1)+pmflxs(i,j+1)+pmflxr(i,j)+pmflxs(i,j))
-     ENDDO
-  ENDDO
+!jyg<
+!!  ! ======================================================
+!!  ! calcul de l'impaction
+!!  ! ======================================================
+!!
+!!  ! impaction sur la surface de la colonne de la descente insaturee
+!!  ! On prend la moyenne des precip entre le niveau i+1 et i
+!!  ! I=3/4* (P(1+1)+P(i))/2 / (sigd*r*rho_l)
+!!  ! 1000kg/m3= densite de l'eau
+!!  ! 0.75e-3 = 3/4 /1000
+!!  ! Par la suite, I est tout le temps multiplie par sig_d pour avoir l'impaction sur la surface de la maille
+!!!!  ! on le neglige ici pour simplifier le code
+!!
+!!  DO j=1,klev-1
+!!     DO i=1,klon
+!!        imp(i,j) = coefcoli_3d(i,j)*0.75e-3/rdrop *&
+!!             0.5*(pmflxr(i,j+1)+pmflxs(i,j+1)+pmflxr(i,j)+pmflxs(i,j))
+!!     ENDDO
+!!  ENDDO
+!>jyg
   !
   ! initialisation pour flux de traceurs, td et autre
@@ -237,4 +239,24 @@
   END DO
 
+!jyg<
+  ! ======================================================
+  ! calcul de l'impaction
+  ! ======================================================
+
+  ! impaction sur la surface de la colonne de la descente insaturee
+  ! On prend la moyenne des precip entre le niveau i+1 et i
+  ! I=3/4* (P(1+1)+P(i))/2 / (sigd*r*rho_l)
+  ! 1000kg/m3= densite de l'eau
+  ! 0.75e-3 = 3/4 /1000
+  ! Par la suite, I est tout le temps multiplie par sig_d pour avoir l'impaction sur la surface de la maille
+  ! on le neglige ici pour simplifier le code
+
+  DO j=1,klev-1
+     DO i=1,klon
+        imp(i,j) = coefcoli_3d(i,j)*0.75e-3/rdrop *&
+             0.5*(pmflxr(i,j+1)+pmflxs(i,j+1)+pmflxr(i,j)+pmflxs(i,j))
+     ENDDO
+  ENDDO
+!>jyg
   ! =========================================
   ! calcul des tendances liees au downdraft
Index: /LMDZ5/trunk/libf/phylmd/lsc_scav.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/lsc_scav.F90	(revision 2283)
+++ /LMDZ5/trunk/libf/phylmd/lsc_scav.F90	(revision 2284)
@@ -1,5 +1,9 @@
 !$Id $
 
-SUBROUTINE lsc_scav(pdtime,it,iflag_lscav,oliq,flxr,flxs,rneb,beta_fisrt,  &
+SUBROUTINE lsc_scav(pdtime,it,iflag_lscav,  &
+!jyg<
+                    aerosol,  &
+!>jyg
+                    oliq,flxr,flxs,rneb,beta_fisrt,  &
                     beta_v1,pplay,paprs,t,tr_seri,d_tr_insc,          &
                     d_tr_bcscav,d_tr_evap,qPrls) 
@@ -37,4 +41,5 @@
   REAL,DIMENSION(klon,klev),INTENT(IN)   :: t        ! temperature
 ! tracers
+  LOGICAL,DIMENSION(nbtr), INTENT(IN)         :: aerosol
   REAL,DIMENSION(klon,klev,nbtr),INTENT(IN)   :: tr_seri        ! q de traceur  
   REAL,DIMENSION(klon,klev),INTENT(IN)        :: beta_fisrt     ! taux de conversion de l'eau cond
@@ -172,5 +177,10 @@
   ENDDO
 
-    IF (it.gt.1) THEN                               !  aerosol   
+!jyg<
+!!    IF (it.gt.1) THEN                               !  aerosol   
+!! Temporary correction: all non-aerosol tracers are dealt with in the same way.
+!! Should be updated once it has been decided how gases should be dealt with.
+    IF (aerosol(it)) THEN
+!>jyg
       frac_ev=frac_aer
     ELSE                                                !  gas
@@ -178,5 +188,8 @@
     ENDIF
 
-    IF(it.gt.1) then  ! aerosol
+!jyg<
+!!    IF (it.gt.1) THEN                               !  aerosol   
+    IF (aerosol(it)) THEN
+!>jyg
      DO k=1, klev
       DO i=1, klon 
@@ -214,5 +227,8 @@
 
 !  below-cloud impaction
-    IF(it.eq.1) then
+!jyg<
+!!    IF (it.eq.1) THEN
+    IF (.NOT.aerosol(it)) THEN
+!>jyg
       d_tr_bcscav(i,k,it)=0.
     ELSE
Index: /LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 2283)
+++ /LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 2284)
@@ -215,5 +215,9 @@
          lcc, lcc3d, lcc3dcon, lcc3dstra, reffclwtop, &
          ec550aer, flwc, fiwc, t_seri, theta, q_seri, &
-         ql_seri, zphi, u_seri, v_seri, omega, cldfra, &
+!jyg<
+!!         ql_seri, zphi, u_seri, v_seri, omega, cldfra, &
+         ql_seri, tr_seri, &
+         zphi, u_seri, v_seri, omega, cldfra, &
+!>jyg
          rneb, rnebjn, zx_rh, d_t_dyn, d_q_dyn, &
          d_u_dyn, d_v_dyn, d_t_con, d_t_ajsb, d_t_ajs, &
@@ -1452,5 +1456,8 @@
               IF (type_trac == 'lmdz' .OR. type_trac == 'repr') THEN
 
-             CALL histwrite_phy(o_trac(iq-nqo), qx(:,:,iq))
+!jyg<
+!!             CALL histwrite_phy(o_trac(iq-nqo), qx(:,:,iq))
+             CALL histwrite_phy(o_trac(iq-nqo), tr_seri(:,:,iq-nqo))
+!>jyg
              CALL histwrite_phy(o_dtr_vdf(iq-nqo),d_tr_cl(:,:,iq-nqo))
              CALL histwrite_phy(o_dtr_the(iq-nqo),d_tr_th(:,:,iq-nqo))
@@ -1469,5 +1476,8 @@
              IF(vars_defined) THEN
                 DO k=1,klev
-                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*qx(:,k,iq)
+!jyg<
+!!                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*qx(:,k,iq)
+                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,iq-nqo)
+!>jyg
                 ENDDO
              ENDIF
Index: /LMDZ5/trunk/libf/phylmd/phytrac_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phytrac_mod.F90	(revision 2283)
+++ /LMDZ5/trunk/libf/phylmd/phytrac_mod.F90	(revision 2284)
@@ -769,5 +769,8 @@
              ! Liu (2001) proposed to use 1.5e-3 kg/kg
 
-             CALL lsc_scav(pdtphys,it,iflag_lscav,ql_incl,prfl,psfl,rneb,beta_fisrt,  &
+!jyg<
+!!             CALL lsc_scav(pdtphys,it,iflag_lscav,ql_incl,prfl,psfl,rneb,beta_fisrt,  &
+             CALL lsc_scav(pdtphys,it,iflag_lscav,aerosol,ql_incl,prfl,psfl,rneb,beta_fisrt,  &
+!>jyg
                   beta_v1,pplay,paprs,t_seri,tr_seri,d_tr_insc,   &
                   d_tr_bcscav,d_tr_evapls,qPrls)